/* EPITA SPE 2010/2011       */
/* Contrôle 2 - Février 2011 */
/* question09                */

#define QNUM 9
#define QOPT "graine taille"
#define QNOPT 2

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include "base_test.h"
#include "question09.h"

list build_list(size_t len, size_t *max)
{
  list			l=NULL, tmp;
  unsigned		c=1;
  if (len)
    {
      l = malloc(sizeof (struct s_list));
      l->data = c;
      l->next = NULL;
      len--;
    }
  tmp = l;
  for (;len; len--)
    {
      tmp->next = malloc(sizeof (struct s_list));
      tmp = tmp->next;
      tmp->data = (c += random()%32);
      tmp->next = NULL;
    }
  *max = c;
  return l;
}

void print(list l)
{
  printf("l = [");
  for(; l; l = l->next)
    printf(" %03d;",l->data);
  printf("]\n");
}

int main(int argc,char *argv[])
{
  size_t        size, max, n;
  list		l=NULL;

  help_asked(argc,argv,QNUM,QOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      l = build_list(size,&max);
      print(l);

      n = 1 + max + random()%32 ;
      max = n;
      printf("\ninsert(%03d,l);\n",n);
      insert(n,&l);
      print(l);

      n = 0;
      printf("\ninsert(%03d,l);\n",n);
      insert(n,&l);
      print(l);

      n = 1 + random()%max;
      printf("\ninsert(%03d,l);\n",n);
      insert(n,&l);
      print(l);

    }
  exit(0);
}
