/* EPITA SPE 2010/2011       */
/* Contrôle 2 - Février 2011 */
/* question10                */

#define QNUM 10
#define QOPT "graine taille"
#define QNOPT 2

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include "base_test.h"
#include "question10.h"

list build_list(size_t len)
{
  list			l=NULL, tmp;
  if (len)
    {
      l = malloc(sizeof (struct s_list));
      l->data = random()%256;
      l->next = NULL;
      len--;
    }
  tmp = l;
  for (;len; len--)
    {
      tmp->next = malloc(sizeof (struct s_list));
      tmp = tmp->next;
      tmp->data = random()%256;
      tmp->next = NULL;
    }
  return l;
}

list build_clist(size_t len)
{
  list			l=NULL, tmp;
  if (len)
    {
      l = malloc(sizeof (struct s_list));
      l->data = random()%256;
      l->next = NULL;
      len--;
    }
  tmp = l;
  for (;len; len--)
    {
      tmp->next = malloc(sizeof (struct s_list));
      tmp = tmp->next;
      tmp->data = random()%256;
      tmp->next = NULL;
    }
  if (l) tmp->next = l;
  return l;
}

static inline int f(int x)
{
  return x?1:0;
}

void print(list l, size_t len)
{
  printf("l = [");
  for(size_t i=0; l && i<len; l = l->next, i++)
    printf(" %03d;",l->data);
  if (l) printf(" ... ");
  printf("]\n");
}

int main(int argc,char *argv[])
{
  size_t        size;
  list		l=NULL, l2=NULL;

  help_asked(argc,argv,QNUM,QOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      if (!size)
	{
	  fprintf(stderr,"La taille doit etre strictement positive.\n");
	  exit(0);
	}

      printf("not_circullar(NULL) = %d (should print 1)\n",f(not_circullar(l)));

      l = build_list(size);
      print(l,size);
      printf("not_circullar(l) = %d (should print 1)\n",f(not_circullar(l)));

      l2 = build_clist(size);
      print(l2,size);
      printf("not_circullar(l) = %d (should print 0)\n",f(not_circullar(l2)));


    }
  exit(0);
}
